# 目录

* [第一章 语言基础](ch1-basic/readme.md)
   * [1.1. Go语言创世纪](ch1-basic/ch1-01-genesis.md)
   * [1.2. Hello, World 的革命](ch1-basic/ch1-02-hello-revolution.md)
   * [1.3. 数组、字符串和切片](ch1-basic/ch1-03-array-string-and-slice.md)
   * [1.4. 函数、方法和接口](ch1-basic/ch1-04-func-method-interface.md)
   * [1.5. 面向并发的内存模型](ch1-basic/ch1-05-mem.md)
   * [1.6. 常见的并发模式](ch1-basic/ch1-06-goroutine.md)
   * [1.7. 错误和异常](ch1-basic/ch1-07-error-and-panic.md)
   * [1.8. 配置开发环境](ch1-basic/ch1-08-ide.md)
* [第二章 CGO编程](ch2-cgo/readme.md)
   * [2.1. 快速入门](ch2-cgo/ch2-01-hello-cgo.md)
   * [2.2. CGO基础](ch2-cgo/ch2-02-basic.md)
   * [2.3. 类型转换](ch2-cgo/ch2-03-cgo-types.md)
   * [2.4. 函数调用](ch2-cgo/ch2-04-func.md)
   * [2.5. 内部机制](ch2-cgo/ch2-05-internal.md)
   * [2.6. 实战: 封装qsort](ch2-cgo/ch2-06-qsort.md)
   * [2.7. CGO内存模型](ch2-cgo/ch2-07-memory.md)
   * [2.8. C++类包装](ch2-cgo/ch2-08-class.md)
   * [2.9. 静态库和动态库](ch2-cgo/ch2-09-static-shared-lib.md)
   * [2.10. Go实现Python模块](ch2-cgo/ch2-10-py-module.md)
   * [2.11. 编译和链接参数](ch2-cgo/ch2-11-link.md)
   * [2.12. 补充说明](ch2-cgo/ch2-12-faq.md)
* [第三章 汇编语言](ch3-asm/readme.md)
   * [3.1. 快速入门](ch3-asm/ch3-01-basic.md)
   * [3.2. 计算机结构](ch3-asm/ch3-02-arch.md)
   * [3.3. 常量和全局变量](ch3-asm/ch3-03-const-and-var.md)
   * [3.4. 函数](ch3-asm/ch3-04-func.md)
   * [3.5. 控制流](ch3-asm/ch3-05-control-flow.md)
   * [3.6. 再论函数](ch3-asm/ch3-06-func-again.md)
   * [3.7. 例子：Goroutine ID](ch3-asm/ch3-07-goroutine-id.md)
   * [3.8. 补充说明](ch3-asm/ch3-08-faq.md)
* [第四章 RPC和Protobuf](ch4-rpc/readme.md)
   * [4.1. RPC入门](ch4-rpc/ch4-01-rpc-intro.md)
   * [4.2. Protobuf简介(TODO)](ch4-rpc/ch4-02-pb-intro.md)
   * [4.3. protorpc(TODO)](ch4-rpc/ch4-03-protorpc.md)
   * [4.4. grpc(TODO)](ch4-rpc/ch4-04-grpc.md)
   * [4.5. 反向rpc(TODO)](ch4-rpc/ch4-05-reverse-rpc.md)
   * [4.6. Protobuf扩展(TODO)](ch4-rpc/ch4-06-pb-option.md)
   * [4.7. 基于pb的rpc定制(TODO)](ch4-rpc/ch4-07-pb-rpc.md)
   * [4.8. 补充说明(TODO)](ch4-rpc/ch4-08-faq.md)
* [第五章 Go和Web](ch5-web/readme.md)
   * [5.1. Web开发简介](ch5-web/ch5-01-introduction.md)
   * [5.2. Router请求路由](ch5-web/ch5-02-router.md)
   * [5.3. Middleware中间件](ch5-web/ch5-03-middleware.md)
   * [5.4. Validator请求校验](ch5-web/ch5-04-validator.md)
   * [5.5. Database和数据库打交道](ch5-web/ch5-05-database.md)
   * [5.6. Ratelimit 服务流量限制](ch5-web/ch5-06-ratelimit.md)
   * [5.7. Layout大型web项目分层](ch5-web/ch5-07-layout-of-web-project.md)
   * [5.8. interface 和 table-driven 开发](ch5-web/ch5-08-interface-and-web.md)
   * [5.9. 灰度发布和 A/B test](ch5-web/ch5-09-gated-launch.md)
   * [5.10. 服务发现](ch5-web/ch5-10-service-discovery.md)
   * [5.11. Load-balance负载均衡](ch5-web/ch5-11-load-balance.md)
* [第六章 分布式系统](ch6-cloud/readme.md)
   * [6.1. 云上地鼠(TODO)](ch6-cloud/ch6-01-cloud.md)
   * [6.2. Raft协议(TODO)](ch6-cloud/ch6-02-raft.md)
   * [6.3. 分布式哈希(TODO)](ch6-cloud/ch6-03-hash.md)
   * [6.4. 分布式队列(TODO)](ch6-cloud/ch6-04-queue.md)
   * [6.5. 分布式缓存(TODO)](ch6-cloud/ch6-05-cache.md)
   * [6.6. etcd(TODO)](ch6-cloud/ch6-06-etcd.md)
   * [6.7. confd(TODO)](ch6-cloud/ch6-07-confd.md)
   * [6.8. 分布式锁(TODO)](ch6-cloud/ch6-08-lock.md)
   * [6.9. 分布式任务调度系统(TODO)](ch6-cloud/ch6-09-sched.md)
   * [6.10. 延时任务系统(TODO)](ch6-cloud/ch6-10-delay-job.md)
   * [6.11. Kubernetes(TODO)](ch6-cloud/ch6-11-k8s.md)
   * [6.12. 补充说明(TODO)](ch6-cloud/ch6-12-faq.md)
* [附录](appendix/readme.md)
   * [附录A: Go语言常见坑](appendix/appendix-a-trap.md)
   * [附录B: 有趣的代码片段](appendix/appendix-b-gems.md)
   * [附录C: 作者简介](appendix/appendix-c-author.md)
